WriteLiveHTML[f_String, g_, (opts___)?OptionQ] := 
    Module[{WIDTH, HEIGHT, HSPACE, VSPACE, ALIGN, BGCOLOR, MAGNIFICATION, 
      SPINX, SPINY, INITIAlROTATION, INDEPENDENTVARIABLES, 
      DEPENDENTVARIABLES, MOUSEDRAGACTION}, 
     WIDTH = width /. {opts} /. Options[WriteLiveHTML]; 
      HEIGHT = height /. {opts} /. Options[WriteLiveHTML]; 
      HSPACE = hspace /. {opts} /. Options[WriteLiveHTML]; 
      VSPACE = vspace /. {opts} /. Options[WriteLiveHTML]; 
      ALIGN = align /. {opts} /. Options[WriteLiveHTML]; 
      BGCOLOR = bgcolor /. {opts} /. Options[WriteLiveHTML]; 
      MAGNIFICATION = magnification /. {opts} /. Options[WriteLiveHTML]; 
      SPINX = spinx /. {opts} /. Options[WriteLiveHTML]; 
      SPINY = spiny /. {opts} /. Options[WriteLiveHTML]; 
      INITIALROTATION = initialrotation /. {opts} /. Options[WriteLiveHTML]; 
      INDEPENDENTVARIABLES = dependentVariables /. {opts} /. 
        Options[WriteLiveHTML]; DEPENDENTVARIABLES = 
       independentVariables /. {opts} /. Options[WriteLiveHTML]; 
      MOUSEDRAGACTION = mousedragaction /. {opts} /. Options[WriteLiveHTML]; 
      hf = OpenWrite[StringJoin[f, ".html"]]; WriteString[hf, 
       "<HTML><BODY>\n"]; WriteString[hf, StringJoin[
        "<APPLET ARCHIVE=\"live.jar\" ALT=\"", f, "\" CODE=\"Live.class\"", 
        " WIDTH=", ToString[WIDTH], " HEIGHT=", ToString[HEIGHT], " VSPACE=", 
        ToString[VSPACE], " HSPACE=", ToString[HSPACE], " ALIGN=", 
        ToString[ALIGN], ">\n"]]; WriteString[hf, 
       StringJoin["<PARAM NAME=\"BGCOLOR VALUE=", ToString[BGCOLOR], ">\n"]]; 
      WriteString[hf, StringJoin["<PARAM NAME=\"MAGNIFICATION\" VALUE=", 
        ToString[MAGNIFICATION], ">\n"]]; WriteString[hf, 
       StringJoin["<PARAM NAME=\"SPIN_X\" VALUE=", ToString[SPINX], ">\n"]]; 
      WriteString[hf, StringJoin["<PARAM NAME=\"SPIN_Y\" VALUE=", 
        ToString[SPINY], ">\n"]]; WriteString[hf, 
       StringJoin["<PARAM NAME=\"INITIAL_ROTATION\" VALUE=", 
        ToString[INITIALROTATION], ">\n"]]; WriteString[hf, 
       StringJoin["<PARAM NAME=\"INDEPENDENT_VARIABLES\" VALUE=\"", 
        ToString[independentVariables], "\">\n"]]; 
      WriteString[hf, StringJoin[
        "<PARAM NAME=\"DEPENDENT_VARIABLES\" VALUE=\"", 
        ToString[dependentVariables], "\">\n"]]; WriteString[hf, 
       StringJoin["<PARAM NAME=\"MOUSE_DRAG_ACTION\" VALUE=", 
        ToString[MOUSEDRAGACTION], ">\n"]]; WriteString[hf, 
       StringJoin["<PARAM NAME=\"INPUT_FILE\" VALUE=\"", f, ".m\">\n"]]; 
      WriteString[hf, "</APPLET>\n"]; WriteString[hf, "</BODY></HTML>\n"]; 
      Close[hf]; WriteLiveForm[StringJoin[f, ".m"], g]]
 
Options[WriteLiveHTML] = {width -> 800, height -> 600, hspace -> 0, 
     vspace -> 0, align -> "LEFT", bgcolor -> "#FFFFFF", magnification -> 1., 
     spinx -> 10., spiny -> 0., initialrotation -> 0.45, 
     independentVariables -> {}, dependentVariables -> {}, 
     mousedragaction -> "rotating"}
 
WriteLiveForm[filename_, graphics_, animOpts___] := 
    Module[{ps, x}, ps = Unprotect[Real]; Format[x_Real, InputForm] := 
       OutputForm[NumberForm[x, 5, NumberFormat -> 
          (If[#3 == "", #1, SequenceForm[#1, "*^", #3]] & )]]; Protect @@ ps; 
      WriteString[filename, ToString[LiveForm[graphics, animOpts], 
        CharacterEncoding -> None]]; Close[filename]; ps = Unprotect[Real]; 
      Format[x_Real, InputForm] =. ; Protect @@ ps; ]
 
LiveForm[graphics_, animOpts___] := 
    Module[{graphics3d = Switch[graphics, Blank[ContourGraphics], 
        Graphics3D[SurfaceGraphics[graphics]], Blank[DensityGraphics], 
        Graphics3D[SurfaceGraphics[graphics]], Blank[SurfaceGraphics], 
        Graphics3D[graphics], _, graphics]}, Switch[graphics3d, _List, 
      HoldForm[ShowAnimation][NumberForm[InputForm[N[graphics3d]], 5], 
       InputForm[N[Flatten[{animOpts}]]]], _, 
      NumberForm[InputForm[N[graphics3d]], 5]]]
